--- Smac/smacXcoral.c	2006-10-16 16:25:44.000000000 -0400
+++ Smac/smacXcoral.c	2014-12-27 22:32:15.000000000 -0500
@@ -5,5 +5,5 @@
    File: smacXcoral.c
    Path: /home/fournigault/c/X11/xcoral-2.33/Smac/smacXcoral.c
-   Description: 
+   Description:
    Created: Tue Feb 21 13:01:08 MET 1995
    Author: Bruno Pages
@@ -12,9 +12,9 @@
 
    RCS $Revision$ $State$
-   
+
 
    ########################################################################
 
-   Note: 
+   Note:
 
    ########################################################################
@@ -48,4 +48,15 @@
 #endif
 
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../selection.h"
+#include "../main_text.h"
+#include "../warn_box.h"
+#include "../ie_func.h"
+#include "../list_box.h"
+#include "../dial_box.h"
+#include "../BR_Global.h"
+#include "RefDeref_.h"
+
 /*#include "error.h"*/
 #include "FunctionCall_.h"
@@ -56,8 +67,9 @@
 #include "control.h"
 #include "stack.h"
+#include "smacXcoral.h"
 
 /* Le buffer courant */
 
-char * i_buffer_courant;
+Text * i_buffer_courant;
 
 
@@ -77,5 +89,5 @@ extern FILE * yyin;
 
 /* ---------------------------------
-   
+
    Les fonctions appelees par Xcoral
 
@@ -87,12 +99,9 @@ extern FILE * yyin;
    --------------------------------- */
 
-extern FCT(void, ClearSelectionIfNeeded,(char *));
-
-static char * check_parser_error()
+static const char * check_parser_error()
 {
   if (*err_msg) {
     if (! strncmp(err_msg, "parser error", 12)) {
-      extern FCT(void, DisplayWMessage ,(char *, char *, int));
-      
+
       /* Le message n'a pas encore ete affiche */
       DisplayWMessage(err_msg, "Smac error", 1);
@@ -107,25 +116,25 @@ static char * check_parser_error()
    courant est buff (qui n'est pas un vrai char *) */
 
-char * ie_load_file(buff, filename)
-     char * buff;
-     char * filename;
+const char * ie_load_file(buff, filename)
+     Text * buff;
+     const char * filename;
 {
   /* Chargement / evaluation d'un fichier */
-  char * xcoral_lib = 0;
-  char * smaclib = 0;
-  
+  char * xcoral_lib = NULL;
+  char * smaclib = NULL;
+
   ClearSelectionIfNeeded(buff);
-  
+
   i_buffer_courant = buff;
 
   if ((yyin = fopen(filename, "r")) == 0) {
-    char * justname = strrchr(filename, '/');
-    
+    const char * justname = strrchr(filename, '/');
+
     if (justname)
       justname += 1;
     else
       justname = filename;
-    
-    smaclib = (char *) getenv ("XCORAL_SMACLIB");
+
+    smaclib = getenv ("XCORAL_SMACLIB");
     if (!smaclib) {
 	xcoral_lib = malloc(strlen(XCORAL_LIB_DIR) + strlen(justname) + 2);
@@ -136,5 +145,5 @@ char * ie_load_file(buff, filename)
 	sprintf(xcoral_lib, "%s/%s", smaclib, justname);
     }
-    
+
     if ((yyin = fopen(xcoral_lib, "r")) == 0) {
       free(xcoral_lib);
@@ -149,10 +158,10 @@ char * ie_load_file(buff, filename)
   else
     yyinfilename = filename;
-  
+
   yyinflag = 1;
   *err_msg = 0;
   clear_ctrl_c();
   rerun_profile();
-  
+
   {
     jmp_buf come_back;
@@ -160,5 +169,5 @@ char * ie_load_file(buff, filename)
     Object * save_stack_pointer = Stack_Pointer;
     Object * save_frame_pointer = Frame_Pointer;
-    
+
     if (! setjmp(come_back)) {
       pCome_Back = &come_back;
@@ -187,15 +196,10 @@ char * ie_load_file(buff, filename)
 /* Evaluation de la region du buffer buff */
 
-char * ie_eval_region(buff)
-     char * buff;
+const char * ie_eval_region(buff)
+     Text * buff;
 {
-  extern FCT(int, ie_mark_position,(char *));
-  extern FCT(int, ie_current_position,(char *));
-  extern FCT(int, ie_current_line,(char *));
-  extern FCT(void, ie_goto_char,(char *, int));
-  extern FCT(char *, ie_filename,(char *));
-  
+
   ClearSelectionIfNeeded(buff);
-  
+
   i_buffer_courant = buff;
   yyin = 0;
@@ -213,5 +217,5 @@ char * ie_eval_region(buff)
   clear_ctrl_c();
   rerun_profile();
-  
+
   {
     jmp_buf come_back;
@@ -219,5 +223,5 @@ char * ie_eval_region(buff)
     Object * save_stack_pointer = Stack_Pointer;
     Object * save_frame_pointer = Frame_Pointer;
-    
+
     if (! setjmp(come_back)) {
       pCome_Back = &come_back;
@@ -236,5 +240,5 @@ char * ie_eval_region(buff)
   i_buffer_courant = 0;
   i_curseur = i_curseur_sup = 0;
-  
+
   return check_parser_error();
 }
@@ -243,7 +247,7 @@ char * ie_eval_region(buff)
 /* Evaluation du minibuffer */
 
-char * ie_eval_expression(buff, expr)
-     char * buff;
-     char * expr;
+const char * ie_eval_expression(buff, expr)
+     Text * buff;
+     const char * expr;
 {
   int lg = strlen(expr);
@@ -253,10 +257,10 @@ char * ie_eval_expression(buff, expr)
 
   ClearSelectionIfNeeded(buff);
-  
+
   lexpr[0] = '{';
   strcpy(lexpr + 1, expr);
   lexpr[lg + 1] = '}';
   lexpr[lg + 2] = 0;
-  
+
   yyinfilename = 0;
   i_buffer_courant = buff;
@@ -268,5 +272,5 @@ char * ie_eval_expression(buff, expr)
   clear_ctrl_c();
   rerun_profile();
-  
+
   {
     jmp_buf come_back;
@@ -274,5 +278,5 @@ char * ie_eval_expression(buff, expr)
     Object * save_stack_pointer = Stack_Pointer;
     Object * save_frame_pointer = Frame_Pointer;
-    
+
     if (! setjmp(come_back)) {
       pCome_Back = &come_back;
@@ -286,9 +290,10 @@ char * ie_eval_expression(buff, expr)
 
   stop_profile();
-  i_buffer_courant = i_minibuffer = 0;
+  i_buffer_courant = NULL;
+  i_minibuffer = NULL;
   i_curseur = i_curseur_sup = 0;
   numlig = -1;
   free(lexpr);
-  
+
   return check_parser_error();
 }
@@ -297,5 +302,5 @@ char * ie_eval_expression(buff, expr)
 /* appel d'une fonction ou non builtin, par exemple indent_line, s'il
    y a des arguments, ceux-ci ne peuvent etre que des int ou char.
-   
+
    Attention on peut avoir xcoral appelle smac qui appelle xcoral qui
    appelle smac !
@@ -303,7 +308,7 @@ char * ie_eval_expression(buff, expr)
 */
 
-char * ie_call_function(buff, fctname, narg, args)
-     char * buff;
-     char * fctname;
+const char * ie_call_function(buff, fctname, narg, args)
+     Text * buff;
+     const char * fctname;
      int narg;
      int * args;
@@ -315,5 +320,5 @@ char * ie_call_function(buff, fctname, n
 
   ClearSelectionIfNeeded(buff);
-  
+
   i_buffer_courant = buff;
   i_minibuffer = 0;
@@ -329,5 +334,5 @@ char * ie_call_function(buff, fctname, n
     return err_msg;
   }
-  
+
   accept_ctrl_c();
   rerun_profile();
@@ -335,5 +340,5 @@ char * ie_call_function(buff, fctname, n
   case NO_JMP:
     pCome_Back = &come_back;
-    
+
     if (Function__IsBuiltin(fdef))
       call_builtin_function_of_xcoral(fdef, narg);
@@ -346,13 +351,13 @@ char * ie_call_function(buff, fctname, n
   }
   pCome_Back = spcome_back;
-  
+
   stop_profile();
   ignore_ctrl_c();
-  
+
   i_buffer_courant = 0;
   i_curseur = i_curseur_sup = 0;
-  
+
   Reinit_Control();
-  
+
   return (*err_msg) ? err_msg : 0;
 }
@@ -362,9 +367,9 @@ char * ie_call_function(buff, fctname, n
 
 char * ExpandSmacName(s, n, common)
-     char * s;
+     const char * s;
      int * n;
      int * common;
 {
-  char * result = 0;
+  char * result = NULL;
   int rlength = 0;
   static HashItem * item = 0;
@@ -373,15 +378,15 @@ char * ExpandSmacName(s, n, common)
   *n = 0;
   *common = strlen(s);
-  
+
   while (HashTable_Iter(IdentifierHashTable, &item, &entry), item) {
     char * name = (char *) HashItem__Key(item);
-    
+
     if (strstr(name, s) == name) {
       char * nresult =
-	  (char *) malloc((unsigned int) rlength + strlen(name) + 3);
-		 
+	  malloc(rlength + strlen(name) + 3);
+
       if (! nresult)
 	return result;
-	
+
       if (result) bcopy(result, nresult, rlength);
       strcpy(nresult + rlength, name);
@@ -400,71 +405,18 @@ char * ExpandSmacName(s, n, common)
   if ((*n == 1) && (*(result + strlen(result) - 1) == ')'))
     *(result + strlen(result) - 1) = 0;
-  
-  return result;
-}
-
-/* Retourne la liste des fonctions definies, builtin ou non.
-
-   Pour initialiser le processus init doit etre non nul,
-   Les appels retourne un char * qui est le nom d'une fonction
-   a chaque appel, 0 en fin de liste. Il ne doit pas y avoir
-   de chargement/evaluation de code pendant le parcours */
-   
-char * ie_function_list(init)
-     int init;
-{
-  static HashItem * item;
-  static HashItem ** entry;
-  
-  if (init) {
-    item = 0;
-    entry = 0;
-  }
 
-  for (;;) {
-    HashTable_Iter(IdentifierHashTable, &item, &entry);
-
-    if (! item)
-      return 0;
-    else if (Identifier__FunctionDef((Identifier *) HashItem__Data(item)))
-      return (char *) HashItem__Key(item);
-  }
+  return result;
 }
 
 
-/* La meme chose pour les donnees (variables globales) */
-   
-char * ie_data_list(init)
-     int init;
-{
-  static HashItem * item;
-  static HashItem ** entry;
-  
-  if (init) {
-    item = 0;
-    entry = 0;
-  }
-
-  for (;;) {
-    HashTable_Iter(IdentifierHashTable, &item, &entry);
-
-    if (! item)
-      return 0;
-    else if (! Identifier__FunctionDef((Identifier *) HashItem__Data(item)))
-      return (char *) HashItem__Key(item);
-  }
-}
-
-     
 /* ------------------------------------------------
-   
+
    Les fonctions d'Xcoral appelees par l'interprete
-   
+
    ------------------------------------------------ */
 
-Object builtin_current_position(a)		/* la position courante */
-     Instruction ** a;
+static Object builtin_current_position(a)	/* la position courante */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_current_position,(char *));
   Object result;
 
@@ -472,12 +424,11 @@ Object builtin_current_position(a)		/* l
   result = ie_current_position(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_current_char(a)			/* le caractere courant */
-     Instruction ** a;				/* 0 en fin de fichier  */
+static Object builtin_current_char(a)		/* le caractere courant */
+     Instruction **a __attribute__((unused));			/* 0 en fin de fichier  */
 {
-  extern FCT(char, ie_current_char,(char *));
   Object result;
 
@@ -485,12 +436,11 @@ Object builtin_current_char(a)			/* le c
   result = ie_current_char(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_previous_char(a)			/* le caractere precedant */
-     Instruction ** a;				/* 0 en debut de fichier  */
+static Object builtin_previous_char(a)		/* le caractere precedant */
+     Instruction **a __attribute__((unused));			/* 0 en debut de fichier  */
 {
-  extern FCT(char, ie_previous_char,(char *));
   Object result;
 
@@ -498,12 +448,11 @@ Object builtin_previous_char(a)			/* le 
   result = ie_previous_char(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_next_char(a)			/* le caractere suivant */
-     Instruction ** a;				/* 0 en debut de fichier  */
+static Object builtin_next_char(a)		/* le caractere suivant */
+     Instruction **a __attribute__((unused));			/* 0 en debut de fichier  */
 {
-  extern FCT(char, ie_next_char,(char *));
   Object result;
 
@@ -511,12 +460,11 @@ Object builtin_next_char(a)			/* le cara
   result = ie_next_char(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_the_char(a)	/* le caractere correspondant a la position */
-     Instruction ** a;		/* 0 en cas d'erreur  */
+static Object builtin_the_char(a)	/* le caractere correspondant a la position */
+     Instruction ** a;			/* 0 en cas d'erreur  */
 {
-  extern FCT(char, ie_the_char,(char *, int));
   Object result = Eval(*a);
 
@@ -524,11 +472,11 @@ Object builtin_the_char(a)	/* le caracte
   result = ie_the_char(i_buffer_courant, result);
   accept_ctrl_c();
-  
+
   return result;
 }
-Object builtin_goto_previous_char(a)		/* recule d'un caractere */
-     Instruction ** a;				/* si possible */
+
+static Object builtin_goto_previous_char(a)	/* recule d'un caractere */
+     Instruction **a __attribute__((unused));			/* si possible */
 {
-  extern FCT(void, ie_goto_previous_char,(char *));
 
   ignore_ctrl_c();
@@ -538,8 +486,7 @@ Object builtin_goto_previous_char(a)		/*
 }
 
-Object builtin_goto_next_char(a)		/* avance d'un caractere */
-     Instruction ** a;				/* si possible */
+static Object builtin_goto_next_char(a)		/* avance d'un caractere */
+     Instruction **a __attribute__((unused));			/* si possible */
 {
-  extern FCT(void, ie_goto_next_char,(char *));
 
   ignore_ctrl_c();
@@ -549,10 +496,9 @@ Object builtin_goto_next_char(a)		/* ava
 }
 
-Object builtin_goto_char(a)			/* change de position */
+static Object builtin_goto_char(a)		/* change de position */
      Instruction ** a;				/* si possible */
 {
-  extern FCT(void, ie_goto_char,(char *, int));
   Object arg = Eval(*a);
-  
+
   ignore_ctrl_c();
   ie_goto_char(i_buffer_courant, arg);
@@ -561,8 +507,7 @@ Object builtin_goto_char(a)			/* change 
 }
 
-Object builtin_beginning_of_line(a)	/* la position du debut de ligne */
-     Instruction ** a;
+static Object builtin_beginning_of_line(a)	/* la position du debut de ligne */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_beginning_of_line,(char *));
   Object result;
 
@@ -570,12 +515,11 @@ Object builtin_beginning_of_line(a)	/* l
   result = ie_beginning_of_line(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_goto_beginning_of_line(a)	/* va en debut de ligne */
-     Instruction ** a;
+static Object builtin_goto_beginning_of_line(a)	/* va en debut de ligne */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_beginning_of_line,(char *));
 
   ignore_ctrl_c();
@@ -585,8 +529,7 @@ Object builtin_goto_beginning_of_line(a)
 }
 
-Object builtin_end_of_line(a)		/* la position de la fin de ligne */
-     Instruction ** a;
+static Object builtin_end_of_line(a)		/* la position de la fin de ligne */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_end_of_line,(char *));
   Object result;
 
@@ -594,12 +537,11 @@ Object builtin_end_of_line(a)		/* la pos
   result = ie_end_of_line(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_goto_end_of_line(a)		/* va enfin de ligne */
-     Instruction ** a;
+static Object builtin_goto_end_of_line(a)	/* va enfin de ligne */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_end_of_line,(char *));
 
   ignore_ctrl_c();
@@ -609,8 +551,7 @@ Object builtin_goto_end_of_line(a)		/* v
 }
 
-Object builtin_at_end_of_file(a)			/* fin de fichier ? */
-     Instruction ** a;
+static Object builtin_at_end_of_file(a)		/* fin de fichier ? */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_at_end_of_file,(char *));
   Object result;
 
@@ -618,12 +559,11 @@ Object builtin_at_end_of_file(a)			/* fi
   result = ie_at_end_of_file(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_end_of_file(a)		/* la position de la fin de fichier */
-     Instruction ** a;
+static Object builtin_end_of_file(a)		/* la position de la fin de fichier */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_end_of_file,(char *));
   Object result;
 
@@ -631,12 +571,11 @@ Object builtin_end_of_file(a)		/* la pos
   result = ie_end_of_file(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_goto_end_of_file(a)		/* va a la fin du fichier */
-     Instruction ** a;
+static Object builtin_goto_end_of_file(a)	/* va a la fin du fichier */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_end_of_file,(char *));
 
   ignore_ctrl_c();
@@ -646,14 +585,9 @@ Object builtin_goto_end_of_file(a)		/* v
 }
 
-Object builtin_goto_previous_line(a)		/* remonte d'une ligne */
-    Instruction ** a;
+static Object builtin_goto_previous_line(a)	/* remonte d'une ligne */
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_beginning_of_line,(char *));
-  extern FCT(void, ie_goto_next_char,(char *));
-  extern FCT(void, ie_goto_previous_char,(char *));
-  extern FCT(int, ie_current_position,(char *));
-  extern FCT(char, ie_current_char,(char *));
   int col = ie_current_position(i_buffer_courant);
-  
+
   ignore_ctrl_c();
   ie_goto_beginning_of_line(i_buffer_courant);
@@ -669,15 +603,9 @@ Object builtin_goto_previous_line(a)		/*
 }
 
-Object builtin_goto_next_line(a)		/* descend d'une ligne */
-    Instruction ** a;
+static Object builtin_goto_next_line(a)		/* descend d'une ligne */
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_goto_beginning_of_line,(char *));
-  extern FCT(void, ie_goto_end_of_line,(char *));
-  extern FCT(void, ie_goto_next_char,(char *));
-  extern FCT(void, ie_goto_previous_char,(char *));
-  extern FCT(int, ie_current_position,(char *));
-  extern FCT(char, ie_current_char,(char *));
   int col = ie_current_position(i_buffer_courant);
-  
+
   ignore_ctrl_c();
   ie_goto_beginning_of_line(i_buffer_courant);
@@ -691,28 +619,18 @@ Object builtin_goto_next_line(a)		/* des
 }
 
-Object builtin_goto_line(a)			/* change de ligne */
+static Object builtin_goto_line(a)		/* change de ligne */
     Instruction ** a;
 {
-  extern FCT(void, ie_goto_beginning_of_line,(char *));
-  extern FCT(void, ie_goto_end_of_line,(char *));
-  extern FCT(void, ie_goto_end_of_file,(char *));
-  extern FCT(void, ie_goto_next_char,(char *));
-  extern FCT(void, ie_goto_previous_char,(char *));
-  extern FCT(void, ie_goto_char,(char *, int));
-  extern FCT(int, ie_current_position,(char *));
-  extern FCT(char, ie_current_char,(char *));
-  extern FCT(int, ie_line_count,(char *));
-  extern FCT(int, ie_current_line,(char *));
   int nline = Eval(*a);
-  
-  if ((nline >= 0) && 
+
+  if ((nline >= 0) &&
       (nline < ie_line_count(i_buffer_courant)) &&
       (nline != ie_current_line(i_buffer_courant))) {
     int col = ie_current_position(i_buffer_courant);
-  
+
     ignore_ctrl_c();
     ie_goto_beginning_of_line(i_buffer_courant);
     col -= ie_current_position(i_buffer_courant);
-    
+
     if (nline < ie_current_line(i_buffer_courant))
       if (nline < (ie_current_line(i_buffer_courant) / 2)) {
@@ -748,12 +666,11 @@ Object builtin_goto_line(a)			/* change 
     accept_ctrl_c();
   }
-  
+
   return 0;
 }
 
-Object builtin_current_line_to_top(a)
-    Instruction ** a;
+static Object builtin_current_line_to_top(a)
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_current_line_to_top,(char *));
 
   ignore_ctrl_c();
@@ -763,34 +680,31 @@ Object builtin_current_line_to_top(a)
 }
 
-Object builtin_current_line(a)
-    Instruction ** a;
+static Object builtin_current_line(a)
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_current_line,(char *));
   Object result;
-  
+
   ignore_ctrl_c();
   result = ie_current_line(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_line_count(a)
-    Instruction ** a;
+static Object builtin_line_count(a)
+    Instruction **a __attribute__((unused));
 {
-  extern FCT(int, ie_line_count,(char *));
   Object result;
-  
+
   ignore_ctrl_c();
   result = ie_line_count(i_buffer_courant);
   accept_ctrl_c();
-  
+
   return result;
 }
 
-Object builtin_insert_char(a)			/* insere et avance */
+static Object builtin_insert_char(a)		/* insere et avance */
      Instruction ** a;
 {
-  extern FCT(void, ie_insert_char,(char *, int));
   Object arg = Eval(*a);
 
@@ -801,9 +715,8 @@ Object builtin_insert_char(a)			/* inser
 }
 
-Object builtin_insert_string(a)			/* insere et avance */
+static Object builtin_insert_string(a)		/* insere et avance */
      Instruction ** a;
 {
-  extern FCT(void, ie_insert_char,(char *, int));
-  char * str = (char *) Eval(*a);
+  const char * str = (char *) Eval(*a);
 
   ignore_ctrl_c();
@@ -817,8 +730,7 @@ Object builtin_insert_string(a)			/* ins
 }
 
-Object builtin_delete_char(a)			/* detruit caract */
-     Instruction ** a;
+static Object builtin_delete_char(a)		/* detruit caract */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_delete_char,(char *));
 
   ignore_ctrl_c();
@@ -828,8 +740,7 @@ Object builtin_delete_char(a)			/* detru
 }
 
-Object builtin_replace_char(a)		/* remplace sans avancer */
+static Object builtin_replace_char(a)		/* remplace sans avancer */
      Instruction ** a;
 {
-  extern FCT(void, ie_replace_char,(char *, int));
   Object arg = Eval(*a);
 
@@ -840,10 +751,9 @@ Object builtin_replace_char(a)		/* rempl
 }
 
-Object builtin_global_replace(a)
+static Object builtin_global_replace(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_global_replace,(char *, char *, char *));
-  char * before = (char *) Eval(a[0]);
-  char * after = (char *) Eval(a[1]);
+  const char * before = (char *) Eval(a[0]);
+  const char * after = (char *) Eval(a[1]);
   Object result;
 
@@ -859,8 +769,7 @@ Object builtin_global_replace(a)
 }
 
-Object builtin_redisplay(a)			/* reaffiche buff */
-     Instruction ** a;
+static Object builtin_redisplay(a)		/* reaffiche buff */
+     Instruction **a __attribute__((unused));
 {
-  extern FCT(void, ie_redisplay,(char *));
 
   ignore_ctrl_c();
@@ -870,8 +779,7 @@ Object builtin_redisplay(a)			/* reaffic
 }
 
-Object builtin_blink(a)				/* blink le caractere sous */
+static Object builtin_blink(a)			/* blink le caractere sous */
      Instruction ** a;				/* la position donnee */
 {						/* en argument */
-  extern FCT(void, ie_blink,(char *, int));
   Object arg = Eval(*a);
 
@@ -882,9 +790,8 @@ Object builtin_blink(a)				/* blink le c
 }
 
-Object builtin_cmd_shell(a)			/* system */
+static Object builtin_cmd_shell(a)			/* system */
      Instruction ** a;
 {
-  extern FCT(int, ie_cmd_shell,(char *, char *));
-  char * expr = (char *) Eval(*a);
+  const char * expr = (char *) Eval(*a);
   Object result;
 
@@ -900,20 +807,19 @@ Object builtin_cmd_shell(a)			/* system 
 
 static Object strdup_end(s)
-    char * s;
+    const char * s;
 {
   Object result = (Object) ((s) ? RTCMalloc(strlen(s) + 1) : 0);
-  
+
   if (result)
     strcpy((char *) result, s);
-  
+
   accept_ctrl_c();
   return result;
 }
 
-Object builtin_cmd_shell_to_string(a)			/* system */
+static Object builtin_cmd_shell_to_string(a)			/* system */
      Instruction ** a;
 {
-  extern FCT(char *, ie_shell_to_string,(char *, char *));
-  char * expr = (char *) Eval(*a);
+  const char * expr = (char *) Eval(*a);
   char * s1;
   Object s2;
@@ -923,17 +829,16 @@ Object builtin_cmd_shell_to_string(a)			
 #endif
   ignore_ctrl_c();
-  s1 = ie_shell_to_string(i_buffer_courant, expr);
+  s1 = ie_shell_to_string(expr);
   s2 = strdup_end(s1);
-  
+
   free(s1);
   return s2;
 }
 
-Object builtin_msearch(a)			/* msearch(str, fin, sens)   */
+static Object builtin_msearch(a)		/* msearch(str, fin, sens)   */
 						/* va sur le premier caract  */
      Instruction ** a;				/* appartenant a str qui est */
 {						/* avant/apres fin           */
-  extern FCT(int, ie_msearch,(char *, char *, int, int));
-  char * expr = (char *) Eval(*a);
+  const char * expr = (char *) Eval(*a);
   int end = (int) Eval(a[1]);
   int sens = (int) Eval(a[2]);
@@ -951,9 +856,8 @@ Object builtin_msearch(a)			/* msearch(s
 
 
-Object builtin_backward_search(a)
+static Object builtin_backward_search(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_backward_search,(char *, char *));
-  char * str = (char *) Eval(*a);
+  const char * str = (char *) Eval(*a);
   Object result;
 
@@ -968,9 +872,8 @@ Object builtin_backward_search(a)
 }
 
-Object builtin_forward_search(a)
+static Object builtin_forward_search(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_forward_search,(char *, char *));
-  char * str = (char *) Eval(*a);
+  const char * str = (char *) Eval(*a);
   Object result;
 
@@ -986,19 +889,15 @@ Object builtin_forward_search(a)
 
 
-
-Object builtin_create_mode(a)
+static Object builtin_create_mode(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_create_mode,(char *, char *));
-  extern FCT(void, ie_set_mode_suffixes,(char *, char *, char *));
-  extern FCT(void, ie_set_mode_font,(char *, char *, char *));
-  char * nom_mode = (char *) Eval(a[0]);
-  char * suffixes;
-  char * police;
+  const char * nom_mode = (char *) Eval(a[0]);
+  const char * suffixes;
+  const char * police;
 
 #ifdef RUNTIMECHECK
   check_strlen(nom_mode);
 #endif
-  
+
   if (IsaNotEnoughArg(a[1]))
     suffixes = police = 0;
@@ -1010,5 +909,5 @@ Object builtin_create_mode(a)
 
     if (IsaNotEnoughArg(a[2]))
-      police = 0;
+      police = NULL;
     else {
       police = (char *) Eval(a[2]);
@@ -1020,18 +919,17 @@ Object builtin_create_mode(a)
 
   ignore_ctrl_c();
-  ie_create_mode(i_buffer_courant, nom_mode);
-  if (suffixes) ie_set_mode_suffixes(i_buffer_courant, nom_mode, suffixes);
-  if (police) ie_set_mode_font(i_buffer_courant, nom_mode, police);
+  ie_create_mode(nom_mode);
+  if (suffixes) ie_set_mode_suffixes(nom_mode, suffixes);
+  if (police) ie_set_mode_font(nom_mode, police);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_set_mode_suffixes(a)
+static Object builtin_set_mode_suffixes(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_set_mode_suffixes,(char *, char *, char *));
-  char * nom_mode = (char *) Eval(a[0]);
-  char * suffixes = (char *) Eval(a[1]);
+  const char * nom_mode = (char *) Eval(a[0]);
+  const char * suffixes = (char *) Eval(a[1]);
 
 #ifdef RUNTIMECHECK
@@ -1041,16 +939,15 @@ Object builtin_set_mode_suffixes(a)
 
   ignore_ctrl_c();
-  ie_set_mode_suffixes(i_buffer_courant, nom_mode, suffixes);
+  ie_set_mode_suffixes(nom_mode, suffixes);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_set_mode_font(a)
+static Object builtin_set_mode_font(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_set_mode_font,(char *, char *, char *));
-  char * nom_mode = (char *) Eval(a[0]);
-  char * font = (char *) Eval(a[1]);
+  const char * nom_mode = (char *) Eval(a[0]);
+  const char * font = (char *) Eval(a[1]);
 
 #ifdef RUNTIMECHECK
@@ -1060,15 +957,14 @@ Object builtin_set_mode_font(a)
 
   ignore_ctrl_c();
-  ie_set_mode_font(i_buffer_courant, nom_mode, font);
+  ie_set_mode_font(nom_mode, font);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_set_mode(a)
+static Object builtin_set_mode(a)
     Instruction ** a;
 {
-  extern FCT(void, ie_set_mode,(char *, char *));
-  char * nom_mode = (char *) Eval(a[0]);
+  const char * nom_mode = (char *) Eval(a[0]);
 
 #ifdef RUNTIMECHECK
@@ -1079,16 +975,15 @@ Object builtin_set_mode(a)
   ie_set_mode(i_buffer_courant, nom_mode);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
 
-Object builtin_key_def(a)
+static Object builtin_key_def(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_key_def,(char *, char *, char *, char *));
-  char * nom_mode = (char *) Eval(a[0]);
-  char * touches = (char *) Eval(a[1]);
-  char * nom_fonc = (char *) Eval(a[2]);
+  const char * nom_mode = (char *) Eval(a[0]);
+  const char * touches = (char *) Eval(a[1]);
+  const char * nom_fonc = (char *) Eval(a[2]);
 
 #ifdef RUNTIMECHECK
@@ -1099,17 +994,16 @@ Object builtin_key_def(a)
 
   ignore_ctrl_c();
-  ie_key_def(i_buffer_courant, nom_mode, touches, nom_fonc);
+  ie_key_def(nom_mode, touches, nom_fonc);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
 
-Object builtin_last_key(a)			/* retourne le dernier */
-     Instruction ** a;				/* caractere tape */
+static Object builtin_last_key(a)		/* retourne le dernier */
+     Instruction **a __attribute__((unused));			/* caractere tape */
 {
-  extern FCT(int, ie_last_key,(char *));
   Object result;
-  
+
   ignore_ctrl_c();
   result = ie_last_key(i_buffer_courant);
@@ -1119,9 +1013,8 @@ Object builtin_last_key(a)			/* retourne
 }
 
-Object builtin_set_font(a)
+static Object builtin_set_font(a)
      Instruction ** a;
 {
-  extern FCT(void, ie_set_font,(char *, char *));
-  char * nom_font = (char *) Eval(*a);
+  const char * nom_font = (char *) Eval(*a);
 
 #ifdef RUNTIMECHECK
@@ -1132,15 +1025,14 @@ Object builtin_set_font(a)
   ie_set_font(i_buffer_courant, nom_font);
   accept_ctrl_c();
-  
+
   return 0;
 }
 
-Object builtin_read_file(a)
+static Object builtin_read_file(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_read_file,(char *, char *));
-  char * filename = (char *) Eval(*a);
+  const char * filename = (char *) Eval(*a);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(filename);
@@ -1153,9 +1045,8 @@ Object builtin_read_file(a)
 }
 
-Object builtin_save_file(a)
-    Instruction ** a;
+static Object builtin_save_file(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(void, ie_save_file,(char *));
-  
+
   ignore_ctrl_c();
   ie_save_file(i_buffer_courant);
@@ -1165,10 +1056,9 @@ Object builtin_save_file(a)
 }
 
-Object builtin_write_file(a)
+static Object builtin_write_file(a)
     Instruction ** a;
 {
-  extern FCT(void, ie_write_file,(char *, char *));
-  char * filename = (char *) Eval(*a);
-  
+  const char *filename = (const char *)Eval(*a);
+
 #ifdef RUNTIMECHECK
   check_strlen(filename);
@@ -1181,10 +1071,9 @@ Object builtin_write_file(a)
 }
 
-Object builtin_current_buffer_is_modified(a)
-    Instruction ** a;
+static Object builtin_current_buffer_is_modified(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_current_buffer_is_modified,(char *));
   int result;
-  
+
   ignore_ctrl_c();
   result = ie_current_buffer_is_modified(i_buffer_courant);
@@ -1194,11 +1083,10 @@ Object builtin_current_buffer_is_modifie
 }
 
-Object builtin_insert_file(a)
+static Object builtin_insert_file(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_insert_file,(char *, char *));
-  char * filename = (char *) Eval(*a);
+  const char *filename = (const char *)Eval(*a);
   Object result;
-  
+
 #ifdef RUNTIMECHECK
   check_strlen(filename);
@@ -1211,28 +1099,25 @@ Object builtin_insert_file(a)
 }
 
-Object builtin_filename(a)
-    Instruction ** a;
+static Object builtin_filename(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(char *, ie_filename,(char *));
-  
+
   ignore_ctrl_c();
   return strdup_end(ie_filename(i_buffer_courant));
 }
 
-Object builtin_current_mode(a)
-    Instruction ** a;
+static Object builtin_current_mode(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(char *, ie_current_mode,(char *));
-  
+
   ignore_ctrl_c();
   return strdup_end(ie_current_mode(i_buffer_courant));
 }
 
-Object builtin_window_height(a)
-    Instruction ** a;
+static Object builtin_window_height(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_window_height,(char *));
   int result;
-  
+
   ignore_ctrl_c();
   result = ie_window_height(i_buffer_courant);
@@ -1242,11 +1127,10 @@ Object builtin_window_height(a)
 }
 
-Object builtin_window_width(a)
+static Object builtin_window_width(a)
     Instruction ** a;
 {
-  extern FCT(int, ie_window_width,(char *, char));
   char c = Eval(*a);
   int result;
-  
+
   ignore_ctrl_c();
   result = ie_window_width(i_buffer_courant, c);
@@ -1256,19 +1140,17 @@ Object builtin_window_width(a)
 }
 
-Object builtin_file_select(a)
-    Instruction ** a;
+static Object builtin_file_select(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(char *, ie_file_select,(char *));
-  
+
   ignore_ctrl_c();
   return strdup_end(ie_file_select(i_buffer_courant));
 }
 
-Object builtin_current_window(a)
-    Instruction ** a;
+static Object builtin_current_window(a)
+    Instruction ** a __attribute__((unused));
 {
-  extern FCT(int, ie_current_window,(char *));
   int result;
-  
+
   ignore_ctrl_c();
   result = ie_current_window(i_buffer_courant);
